/** Demo the development of a few methods. */
public class D {

    /** = the middle value of b, c, d */
    public int middle(int b, int c, int d) {
        if (b <= c  &&  c <= d) {
            return c;
        }
        if (d <= c  &&  c <= b) {
            return c;
        }
        // the middle value is b or d
        if (c <= b  &&  b <= d) {
            return b;
        }
        if (d <= b  &&  b <= c) {
            return b;
        }
        // middle value is d
        return d;
    }

    /** Print the middle value of b, c, d. */
    public void middlePrint(int b, int c, int d) {
        if (b <= c  &&  c <= d) {
            System.out.println(c);
            return;
        }
        if (d <= c  &&  c <= b) {
            System.out.println(c);
            return;
        }
        // the middle value is b or d
        if (c <= b  &&  b <= d) {
            System.out.println(b);
            return;
        }
        if (d <= b  &&  b <= c) {
            System.out.println(b);
            return;
        }
        // middle value is d
        System.out.println(d);

    }

    /** =  "b, c, d form the sides of a triangle",
     * i.e. all are > 0 and each is smaller than the sum of the other two.  */
    public boolean isTriangle(double b, double c, double d) {
        return b > 0  &&  c > 0  &&  d > 0  &&
                b+c > d  &&  c+d > b  &&  d+b > c;

    }

    /** Return true if the date given by y1, m1, d1 comes before the date given
     * by y2, m2, d2 and false otherwise.
     * OR
     * Return "(y1, m1, d1) comes before (y2, m2, d2)" 
     * Note: y's are years, m are months, in 1..12, and d's are the day of the month*/
    public boolean comesBefore(int y1, int m1, int d1, int y2, int m2, int d2) {
        return (y1 < y2 ||
                (y1 == y2  &&  m1 < m2) ||
                (y1 == y2  &&  m1 == m2  &&  d1 < d2));
    }


    /** Return "b is not 0 and 10000/b is even". 
     *  i.e. return true if b is not 0 and 10000/b is even and return false otherwise. */
    public boolean checkB(int b) {
        return b != 0  &&  (10000 / b) % 2 == 0;
    }

    /** Return the value sqrt(b*b - 4 a c) */
    public double sqrt(double b, double a, double c) {
        return Math.sqrt(b*b - 4 * a * c);
    }


    /** Return the area of the smaller of the two circles whose radii are r1 and r2.
     * Precondition: r1 > 0 and r2 > 0. */



    /** If c is a lower-case letter that is not 'z', return the next lower-case
     * letter is dictionary order.
     * If c is an upper-case letter that is not 'A', return the preceding
     * upper-case letter.
     * In all other cases, return the character whose internal representation is
     * the square of the internal representation of c. */




}
